﻿package com.callystro.engine
{
	import flash.display.MovieClip;
	import flash.display.*;
	import flash.events.Event;
	import flash.net.*;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.external.ExternalInterface;	
	import flash.events.StatusEvent //Samz
	import flash.net.LocalConnection;//Samz To Pass Score	

	public class ScoreSaver extends MovieClip
	{
		public var sending_lc:LocalConnection;
		private var frame : MovieClip;
		private var environment:String="";
		private static var sendScoreToMotherApp:Function; //-------------------------Updated for Android
		public static var finalScore:int = 0;
		
		
		public function ScoreSaver(timeLine:MovieClip)
		{
			trace("Score saver Initialized");
			this.frame = timeLine;
			sending_lc = new LocalConnection();
			sending_lc.addEventListener(StatusEvent.STATUS, onLCStatus);
		}
		
		public function saveScore(score:int)
		{
			try
			{
				trace("Try block");
				environment = ExternalInterface.call("GetApp");
				if(ScoreSaver.sendScoreToMotherApp != null)
				{
					trace("Android Platform");
					ScoreSaver.sendScoreToMotherApp(score);
				}
			}
			catch(error:Error)
			{
				trace("Exception Handler");
				environment = "Local";
			}
			
			trace("environment  :  "+environment);
			
			if (environment=="Mapoosa")
			{
				sending_lc.send("_gameToEngine", "saveScore", score,-1);
			}
			else if (environment=="Cobels")
			{
				ExternalInterface.call("SaveGameScore", score);
			}
			else
			{
				finalScore = score;
				trace("Local System Score");
			}
		}
		
		//------------------------------------------------------------------------------Updated for Android
		public static function setAndroidScoreSaver(sendScoreToMotherApp:Function):void
		{			
			ScoreSaver.sendScoreToMotherApp=sendScoreToMotherApp;
			trace("score saver for mother app is set..");
		}
		//------------------------------------------------------------------------------
				
		public function onLCStatus(event:StatusEvent):void
		{
			trace("onLCStatus in sending side:"+event.code);
		}
	}
}