﻿package com.callystro.resource {
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.media.Sound;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	
	public class ResourceLoader {
		
		public var fractionComplete:Number = 0;
		public var completed:Boolean = false;
		public var resource:Resource;
		public var errorOccured:Boolean = false;
		
		public function ResourceLoader(resource:Resource){
			this.resource = resource;
		}
		
		protected function calculateFractionComplete(e:ProgressEvent):void{
			var percentComplete:Number;
			try {
				percentComplete = e.bytesLoaded / e.bytesTotal;
			} catch(e:Error){}
			if((!isNaN(percentComplete)) && (percentComplete > fractionComplete)){
				fractionComplete = percentComplete;
			}
		}
		
		protected function loadComplete(e:Event):void{
			fractionComplete = 1;
			completed = true;
			dispose();
		}
		
		protected function loadError(e:Event):void{
			trace("Resource Load Error");
			trace(""+(e as Object).toString());
			resource.errorOccuredWhileLoading = true;
			errorOccured = true;
			dispose();
		}
		
		public function dispose():void {
			resource = null;
		}
	}
}