﻿package com.callystro.sound {
	
	import flash.events.Event;
	
	public class MutePlayBackSoundManager extends SoundManager {
		
		public function MutePlayBackSoundManager(soundInstanceContainer:SoundInstanceContainer){
			super(soundInstanceContainer);
		}
		
		override public function play(soundInstance:SoundInstance):void {
			soundInstanceContainer.addSoundInstance(soundInstance);
			soundInstance.addEventListener(SoundInstance.SOUND_COMPLETE,soundCompleteHandler);
			soundInstance.addEventListener(SoundInstance.SOUND_STOPPED,soundStoppedHandler);
			soundInstance.play();
		}
		
		override protected function initialize():void {
			var allSoundInstances:Array;
			allSoundInstances = soundInstanceContainer.getAllSoundInstances();
			for(var i:int = 0;i < allSoundInstances.length; i++){
				allSoundInstances[i].addEventListener(SoundInstance.SOUND_COMPLETE,soundCompleteHandler);
				allSoundInstances[i].addEventListener(SoundInstance.SOUND_STOPPED,soundStoppedHandler);
			}
		}
	
	}
	
}