﻿package com.callystro.engine 
{
		 import flash.display.DisplayObjectContainer;
		 import flash.display.SimpleButton;
		 import flash.text.TextField;
		 import flash.display.MovieClip;
		 import flash.events.Event;
		 import flash.events.MouseEvent;
		 import flash.media.Sound;
		
		import com.callystro.engine.Constants;
		import com.callystro.resource.MultipleResourceLoader;
		import com.callystro.resource.ResourceContainer;
		import com.callystro.resource.ResourceManager;
		import com.callystro.utils.Util;
		import com.callystro.utils.Mediator;
		import com.callystro.sound.SoundPlayer;

		 /**
		  * ...
		  * @author Rineesh
		  */
    	 public class ButtonHandler 
		 {
		 
				public static var voiceOverKey:String;
				public static var btn:SimpleButton;
				public static var voiceOver:Sound;
				public function ButtonHandler() {}

          		public static function setButtonTextVoice(button:SimpleButton,
														  voiceOverKeys:String = null,
														  textAllowed:Boolean = false, 
													  	  textFormatKey:String = null, 
													  	  textKey:String = null):void 
				{
					   if(textAllowed)
					   {
						   if(textFormatKey && textFormatKey != "")
						   {
							   var samplebtn_doc:DisplayObjectContainer = button.upState as DisplayObjectContainer;
							   var labelsamplebtn:TextField = getTextField(samplebtn_doc);
							   var samplebtn_over:DisplayObjectContainer = button.overState as DisplayObjectContainer;
							   var labelsamplebtn_over:TextField = getTextField(samplebtn_over);
							   var samplebtn_down:DisplayObjectContainer = button.downState as DisplayObjectContainer;
							   var labelsamplebtn_down:TextField = getTextField(samplebtn_down);
							   Util.setText(labelsamplebtn, textFormatKey, textKey);
							   Util.setText(labelsamplebtn_over, textFormatKey, textKey);				   
							   Util.setText(labelsamplebtn_down, textFormatKey, textKey);
						   }
					   }
					   voiceOverKey = voiceOverKeys;
					   btn = button;
					   if(voiceOverKey && voiceOverKey != "")
					   {
							btn.addEventListener(MouseEvent.MOUSE_OVER, playVoiceOver);
							btn.addEventListener(MouseEvent.MOUSE_OUT, stopVoiceOver);
					   }
					   btn.addEventListener(MouseEvent.CLICK, onClick);
          		}

      			private static function getTextField(samplebtn_doc:DisplayObjectContainer):TextField 
				{
				   var temp:Object;
				   for (var i:int = 1; i <= samplebtn_doc.numChildren; i++) 
				   {
						temp = samplebtn_doc.getChildAt(i);
						if (temp is TextField)
							 return (temp as TextField);
				   }
				   return null;
          		}
				
				public static function getButtonText(button:SimpleButton):String
				{
				   var samplebtn_doc:DisplayObjectContainer = button.upState as DisplayObjectContainer;
				   var temp:Object;
				   for (var i:int = 1; i <= samplebtn_doc.numChildren; i++)
				   {
						temp = samplebtn_doc.getChildAt(i);
						if (temp is TextField)
							 return (temp.text);
				   }
				   return null;
          		}  
				
				public static function setImage(btn:SimpleButton):MovieClip
				{
					  var samplebtn_doc:DisplayObjectContainer = btn.upState as DisplayObjectContainer;
					   var temp:MovieClip;
					   for (var i:int = 1; i < samplebtn_doc.numChildren; i++)
					   {
							
							trace(samplebtn_doc.getChildAt(i));
							temp=MovieClip(samplebtn_doc.getChildAt(i));
							return (temp);
					   }
					   return null;
				 } 
		  
				public static function playVoiceOver(e:Event = null):void
				{
					SoundPlayer.play(voiceOverKey,ResourceManager.getInstance().getSound(voiceOverKey),null,1);
				}
				
				public static function stopVoiceOver(e:Event = null):void
				{
					SoundPlayer.stop(voiceOverKey);
				}
				
				public static function onClick(e:Event):void
				{
					//SoundPlayer.play("ClickSound",clickSound);
				}
			
				public static function dispose():void
				{
					btn.removeEventListener(MouseEvent.MOUSE_OVER, playVoiceOver);
					btn.removeEventListener(MouseEvent.MOUSE_OUT, stopVoiceOver);
					btn.removeEventListener(MouseEvent.CLICK, onClick);
					//clickSound = null;
				}
     
      }

}