﻿package com.semnox.engine{
	
	import flash.events.Event;
	import flash.media.Sound;
	
	public class ShowVoiceOverEvent extends Event{
		
		public static const SHOW_VOICE_OVER:String = "ShowVoiceOverEvent.showVoiceOver";
		
		public var voiceOverID:String;
		
		public var voiceOverSound:Sound;
		
		public var voiceOverText:String;
		
		public var completeHandler:Function;
		
		public var completeHandlerArguments:Array;
		
		public var textStays:Boolean;
		
		public var showGlow:Boolean;
				
		public function ShowVoiceOverEvent(voiceOverID:String,
										   voiceOverSound:Sound,
										   voiceOverText:String,
										   completeHandler:Function = null, 
										   completeHandlerArguments:Array = null,
										   textStays:Boolean = true,
										   showGlow:Boolean = false){
			super(SHOW_VOICE_OVER,false,false);
			this.voiceOverID = voiceOverID;
			this.voiceOverSound = voiceOverSound;
			this.voiceOverText = voiceOverText;
			this.completeHandler = completeHandler;
			this.completeHandlerArguments = completeHandlerArguments;
			this.textStays = textStays;
			this.showGlow = showGlow;
		}
		
	}

}