﻿package com.callystro.timer{
	import flash.utils.Dictionary;

	public class TimerUtil {
	
		public static function createCallback(delay:Number,
											  repeatCount:int,
											  intermediateTimerCallBack:Function = null,
											  completeTimerCallBack:Function = null,
											  intermediateTimerCallBackVar:Object = null,
											  completeTimerCallBackVar:Object = null,
											  isOneTime:Boolean = false):CallBackInstance
	   {
		  var callBackInstance:CallBackInstance = new CallBackInstance();
		  callBackInstance.startTimer(delay,
									  repeatCount,
									  intermediateTimerCallBack,
									  completeTimerCallBack,
									  intermediateTimerCallBackVar,
									  completeTimerCallBackVar,
									  isOneTime);
		  return callBackInstance;
	   }
	   
	   public static function createInfiniteCallBack(delay:Number,
											  intermediateTimerCallBack:Function,
											  intermediateTimerCallBackVar:Object = null):CallBackInstance
	   {
		   return createCallback(delay,0,intermediateTimerCallBack,null,intermediateTimerCallBackVar,null);
	   }
	   
	   public static function createOneTimeCallBack(delay:Number,
											 completeTimerCallBack:Function,
											 completeTimerCallBackVar:Object = null):CallBackInstance
		{
			return createCallback(delay,1,null,completeTimerCallBack,null,completeTimerCallBackVar,true);
		}
	   	  
	}

}